#pragma once

namespace Qumela {

	using namespace Genode;

	template <typename T>
	T string_split(const T &input, char delimiter, int part)
	{
		int delimiter_index = -1;
		int last_delimiter = -1;
		char c[input.capacity()];
		memcpy(c, input.string(), input.capacity());

		for (unsigned i = 0; i < input.length(); i++)
		{
			if (c[i] == delimiter) {
				delimiter_index++;

				if (delimiter_index == part)
				{
					c[i] = '\0';
					return T(Cstring(c + last_delimiter + 1));
				}

				last_delimiter = i;
			}
		}

		if (delimiter_index + 1 == part) {
			return T(Cstring(c + last_delimiter + 1));
		} else {
			return T("");
		}
	}
	
	template <typename T>
	T path_split(const T &input, int part)
	{
		return string_split(input, '/', part);
	}

	template <typename T>
	bool is_greater(const T &a, const T &b)
	{
		const char* as = a.string();
		const char* bs = b.string();
		unsigned length = min(a.length(), b.length());

		for (unsigned i = 0; i < length; i++) {
			if (as[i] > bs[i]) {
				return true;
			} else if (as[i] < bs[i]) {
				return false;
			}
		}

		if (a.length() > b.length()) {
			return true;
		} else {
			return false;
		}
	}
}
